
try:
    from pymol import cmd
except ImportError:
    print("PyMOL Python lib is missing")
    # sys.exit(0)

def spl_extract():
 for name in cmd.get_names("all"):
    
    print(" \ Extracting mode for %s" % name)
    if 'h3_6QW6'.lower() in name.lower():
        cmd.extract("PRP8_h3_6QW6", "chain 5A and h3_6QW6")
        cmd.extract("BRR2_h3_6QW6", "chain 5B and h3_6QW6")
        cmd.extract("SNU114_h3_6QW6", "chain 5C and h3_6QW6")
        cmd.extract("U5_h3_6QW6", "chain 5 and h3_6QW6")
        cmd.extract("U6_h3_6QW6", "chain 6 and h3_6QW6")
        cmd.extract("U4_h3_6QW6", "chain 4 and h3_6QW6")
        cmd.extract("PRP4_h3_6QW6", "chain 4B and h3_6QW6")
        cmd.extract("PRP31_h3_6QW6", "chain 4C and h3_6QW6")
        cmd.extract("PRP6_h3_6QW6", "chain 5J and h3_6QW6")
        cmd.extract("PRP3_h3_6QW6", "chain 4A and h3_6QW6")
        cmd.extract("SNU13_h3_6QW6", "chain 4D and h3_6QW6")
        cmd.extract("SNU66_h3_6QW6", "chain S and h3_6QW6")
        cmd.extract("U5-40K_h3_6QW6", "chain 5O and h3_6QW6")
        cmd.extract("DIM1_h3_6QW6", "chain 5D and h3_6QW6")
        cmd.extract("PRP28_h3_6QW6", "chain 5X and h3_6QW6")
        cmd.extract("SAD1_h3_6QW6", "chain U and h3_6QW6")
        cmd.extract("RBM42_h3_6QW6", "chain R and h3_6QW6")
        cmd.extract("SNRNP27_27K_h3_6QW6", "chain X and h3_6QW6")
        cmd.extract("U5_Sm_ring_h3_6QW6", "(chain 51 or chain  52 or chain  53 or chain   5b or chain  5e or chain  5f or chain  5g ) and h3_6QW6")
        cmd.extract("U4_Sm_ring_h3_6QW6", "(chain 41 or chain   42 or chain  43 or chain  4b or chain  4e or chain  4f or chain  4g ) and h3_6QW6")
        cmd.extract("Lsm_ring_h3_6QW6", "(chain 62 or chain  63 or chain  64 or chain  65 or chain  66 or chain  67 or chain 68 ) and h3_6QW6")
        cmd.set_name("h3_6QW6", "unknown_other_h3_6QW6")
        cmd.group("h3_6QW6", "*_h3_6QW6")
        cmd.do("order *, yes")
    if 'hBpre_6QX9'.lower() in name.lower():
        cmd.extract("PRP8_hBpre_6QX9", "chain 5A and hBpre_6QX9")
        cmd.extract("SNU114_hBpre_6QX9", "chain 5C and hBpre_6QX9")
        cmd.extract("U2_hBpre_6QX9", "chain 2 and hBpre_6QX9")
        cmd.extract("U5_hBpre_6QX9", "chain 5 and hBpre_6QX9")
        cmd.extract("U6_hBpre_6QX9", "chain 6 and hBpre_6QX9")
        cmd.extract("U4_hBpre_6QX9", "chain 4 and hBpre_6QX9")
        cmd.extract("Intron_hBpre_6QX9", "chain I and hBpre_6QX9")
        cmd.extract("U1_hBpre_6QX9", "chain 1 and hBpre_6QX9")
        cmd.extract("PRP4_hBpre_6QX9", "chain 4B and hBpre_6QX9")
        cmd.extract("PRP31_hBpre_6QX9", "chain 4C and hBpre_6QX9")
        cmd.extract("PRP6_hBpre_6QX9", "chain 5J and hBpre_6QX9")
        cmd.extract("PRP3_hBpre_6QX9", "chain 4A and hBpre_6QX9")
        cmd.extract("SNU66_hBpre_6QX9", "chain S and hBpre_6QX9")
        cmd.extract("U5-40K_hBpre_6QX9", "chain 5O and hBpre_6QX9")
        cmd.extract("DIM1_hBpre_6QX9", "chain 5D and hBpre_6QX9")
        cmd.extract("PRP28_hBpre_6QX9", "chain 5X and hBpre_6QX9")
        cmd.extract("SAD1_hBpre_6QX9", "chain U and hBpre_6QX9")
        cmd.extract("RBM42_hBpre_6QX9", "chain R and hBpre_6QX9")
        cmd.extract("SNRNP27_27K_hBpre_6QX9", "chain X and hBpre_6QX9")
        cmd.extract("U5_Sm_ring_hBpre_6QX9", "(chain 51 or chain  52 or chain  53 or chain   5b or chain  5e or chain  5f or chain  5g ) and hBpre_6QX9")
        cmd.extract("U4_Sm_ring_hBpre_6QX9", "(chain 41 or chain   42 or chain  43 or chain  4b or chain  4e or chain  4f or chain  4g ) and hBpre_6QX9")
        cmd.extract("Lsm_ring_hBpre_6QX9", "(chain 62 or chain  63 or chain  64 or chain  65 or chain  66 or chain  67 or chain  68 ) and hBpre_6QX9")
        cmd.extract("U1_Sm_ring_hBpre_6QX9", "(chain 11 or chain  12 or chain 13 or chain 1b or chain 1e or chain 1f or chain 1g ) and hBpre_6QX9")
        cmd.extract("U1A_hBpre_6QX9", "chain 1A and hBpre_6QX9")
        cmd.extract("U170k_hBpre_6QX9", "chain 1K and hBpre_6QX9")
        cmd.extract("U1C_hBpre_6QX9", "chain 1C and hBpre_6QX9")
        cmd.extract("SF3B1_hBpre_6QX9", "chain B1 and hBpre_6QX9")
        cmd.extract("SF3B3_hBpre_6QX9", "chain B3 and hBpre_6QX9")
        cmd.extract("SF3B2_hBpre_6QX9", "chain B2 and hBpre_6QX9")
        cmd.extract("SF3B4_hBpre_6QX9", "chain B4 and hBpre_6QX9")
        cmd.extract("PHF5A_hBpre_6QX9", "chain BP and hBpre_6QX9")
        cmd.extract("SF3A3_hBpre_6QX9", "chain A3 and hBpre_6QX9")
        cmd.extract("SF3A2_hBpre_6QX9", "chain A2 and hBpre_6QX9")
        cmd.extract("SF3A1_hBpre_6QX9", "chain A1 and hBpre_6QX9")
        cmd.extract("U2A_hBpre_6QX9", "chain 2A and hBpre_6QX9")
        cmd.extract("U2B_hBpre_6QX9", "chain 2B and hBpre_6QX9")
        cmd.extract("SF3B5_hBpre_6QX9", "chain B5 and hBpre_6QX9")
        cmd.extract("U2_Sm_ring_hBpre_6QX9", "(chain 21 or chain  22 or chain  23 or chain  2b or chain  2e or chain  2f or chain  2g ) and hBpre_6QX9")
        cmd.extract("Prp4Kinase_hBpre_6QX9", "chain K and hBpre_6QX9")
        cmd.set_name("hBpre_6QX9", "unknown_other_hBpre_6QX9")
        cmd.group("hBpre_6QX9", "*_hBpre_6QX9")
        cmd.do("order *, yes")
    if 'hB_6AHD'.lower() in name.lower():
        cmd.extract("PRP8_hB_6AHD", "chain A and hB_6AHD")
        cmd.extract("BRR2_hB_6AHD", "chain D and hB_6AHD")
        cmd.extract("SNU114_hB_6AHD", "chain C and hB_6AHD")
        cmd.extract("U2_hB_6AHD", "chain H and hB_6AHD")
        cmd.extract("U5_hB_6AHD", "chain B and hB_6AHD")
        cmd.extract("U6_hB_6AHD", "chain F and hB_6AHD")
        cmd.extract("U4_hB_6AHD", "chain I and hB_6AHD")
        cmd.extract("Intron_hB_6AHD", "chain G and hB_6AHD")
        cmd.extract("PRP4_hB_6AHD", "chain K and hB_6AHD")
        cmd.extract("PRP31_hB_6AHD", "chain L and hB_6AHD")
        cmd.extract("PRP6_hB_6AHD", "chain N and hB_6AHD")
        cmd.extract("PRP3_hB_6AHD", "chain J and hB_6AHD")
        cmd.extract("DIB1_hB_6AHD", "chain O and hB_6AHD")
        cmd.extract("SNU13_hB_6AHD", "chain M and hB_6AHD")
        cmd.extract("SNU66_hB_6AHD", "chain 9 and hB_6AHD")
        cmd.extract("U5-40K_hB_6AHD", "chain E and hB_6AHD")
        cmd.extract("U5_Sm_ring_hB_6AHD", "(chain a or chain b or chain c or chain d or chain e or chain f or chain g ) and hB_6AHD")
        cmd.extract("U4_Sm_ring_hB_6AHD", "(chain U or chain V or chain P or chain Q or chain R or chain S or chain T ) and hB_6AHD")
        cmd.extract("Lsm_ring_hB_6AHD", "(chain q or chain r or chain s or chain t or chain x or chain y or chain z ) and hB_6AHD")
        cmd.extract("SF3B1_hB_6AHD", "chain 1 and hB_6AHD")
        cmd.extract("SF3B3_hB_6AHD", "chain 3 and hB_6AHD")
        cmd.extract("SF3B2_hB_6AHD", "chain 2 and hB_6AHD")
        cmd.extract("SF3B4_hB_6AHD", "chain 4 and hB_6AHD")
        cmd.extract("PHF5A_hB_6AHD", "chain 6 and hB_6AHD")
        cmd.extract("SF3A3_hB_6AHD", "chain w and hB_6AHD")
        cmd.extract("SF3A2_hB_6AHD", "chain v and hB_6AHD")
        cmd.extract("SF3A1_hB_6AHD", "chain u and hB_6AHD")
        cmd.extract("U2A_hB_6AHD", "chain o and hB_6AHD")
        cmd.extract("U2B_hB_6AHD", "chain p and hB_6AHD")
        cmd.extract("SF3B5_hB_6AHD", "chain 7 and hB_6AHD")
        cmd.extract("U2_Sm_ring_hB_6AHD", "(chain i or chain j or chain k or chain l or chain m or chain n or chain h ) and hB_6AHD")
        cmd.extract("FBP21_hB_6AHD", "chain X and hB_6AHD")
        cmd.extract("PPIH_hB_6AHD", "chain W and hB_6AHD")
        cmd.extract("UBL5_hB_6AHD", "chain A0 and hB_6AHD")
        cmd.extract("MFAP1_hB_6AHD", "chain 0 and hB_6AHD")
        cmd.extract("PRPF38A_hB_6AHD", "chain Z and hB_6AHD")
        cmd.extract("ZMAT2_hB_6AHD", "chain 8 and hB_6AHD")
        cmd.extract("SMU1_hB_6AHD", "chain Y and hB_6AHD")
        cmd.extract("SF3B6_hB_6AHD", "chain 5 and hB_6AHD")
        cmd.set_name("hB_6AHD", "unknown_other_hB_6AHD")
        cmd.group("hB_6AHD", "*_hB_6AHD")
        cmd.do("order *, yes")
